//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef GPLUGINSDK_H
#define GPLUGINSDK_H

#include <qobject.h>
#include <qstring.h>
#include <qimage.h>
#include <qxml.h>
#include <qdom.h>
#include <qtimer.h>
#include <kpopupmenu.h>

// PluginEngine 0.3
// 20/5/2005

class gPluginSDKCfgWnd;
class gPluginPainter;

const char KXDOCKER_VARTYPE_BOOL[] 	= "bool";
const char KXDOCKER_VARTYPE_PERCENT[] 	= "%";
const char KXDOCKER_VARTYPE_INT[] 	= "int";
const char KXDOCKER_VARTYPE_RANGE[] 	= "range";
const char KXDOCKER_VARTYPE_STRING[] 	= "string";
const char KXDOCKER_VARTYPE_ICON[]	= "icon";
const char KXDOCKER_VARTYPE_LIST[]	= "list";
const char KXDOCKER_VARTYPE_PATH[]	= "path";


/**
@author Stefano Zingarini
*/
class gPluginSDK : public QObject
{
Q_OBJECT
public:
    gPluginSDK(QObject *parent = 0, const char *name = 0);

    ~gPluginSDK();
protected:
	int lastValue;
	int Value;
	QObject			*xGDocker;
	QObject			*xEConfigurator;
	void			*pActiveConfiguration;
	int			ActiveConfigurationSizeOf;
	QString			ActiveConfigurationVersion;
	QObject			*xGIcon;
	QImage			*xImgSource;
	const QDomNodeList	*xXMLIconConfig;
	QString			IconsPath;
	QString			ToolTip;
	QString			ToolTip2;
	QString			LastToolTip2;

	QStringList		PluginInformations;
	KPopupMenu		*PluginPopupMenu;
	int 			SizeBig;
	int			ImageFX_Y_degree;
	int			ImageFX_X_degree;
	int			ImageFX_GrayScale;
	int			ImageFX_Intensity;
	gPluginPainter		*ImageFX_Painter;


public slots:
    virtual void xSetup();
    virtual void xRefreshIcon(QObject *);
    virtual void xStop();
    virtual void xStart();
    virtual void xAttach(QObject *);
    virtual void xApplyCfg();
    virtual void polling();
    virtual void xSetupParameter(const QString, const QString);
    virtual void xGetParameterList(QStringList *);
    virtual void xGetParameter(const QString, QString&);
    virtual void xGetInfo(QStringList &);
    virtual void xRunConfigurator();
    virtual void xEnabledClick(int &);
    virtual void xPaint(int);
    virtual void xEventClick(void *,int,int,int,int);
    void xRefreshIconFromKXDocker(QObject *);
    void xGetParameterType(const QString &, QString &);
    void xContinue();
    void xPause();

public:
signals:
    void cachePurge();
    void xSetSmoothZoom();
    void xDockerRedraw(QObject *);
    void xGetDocker(QObject *&);
    void xGetConfigurator(QObject *&);

    void xSetText(const QString &);
    void xGetImage(QImage *&);
    void xGetPluginConfiguration(const QDomNodeList *&);
    void xFindResource(const QString, QString&);
    void xGetPluginPopupMenu(KPopupMenu *&,const QObject *);
    void xSetIconEXE(const QString &);
    void xGetIconEXE(QString &);
    void xGetIconImgFile(QString &);
    void xGetIconName(QString &);
    void xSetIconImgFile(const QString &);
    void xSetIconName(const QString &);
    void xSetOverText(const QString &);
    void xGetConfigurationVersion(int &, QString &);
    void xGetConfiguration(void *&,const QString, int);
    void xGetConfigurationValue(const QString, int &);
    void xGetConfigurationValue(const QString, QString &);
    void xSetText(const QString &, int);
    void xSetMiniText(const QString &);
    void xSetTextManagedBy(int,int);
    void xSetOverlayImage(int,int,const QString &);
    void xSetOverlayImage(int,int,const QImage &);
    void xSetOverlayImage(int,int,const QPixmap &);
    void xStartStepping();
    void xAskContinue(QObject *);
protected:
    void createXMLTree();
    void xPaintFX(int);
	gPluginSDKCfgWnd *ConfigurationWindow;
	int isStopped;
};

#endif
